Subject: Re: Latest Git kernel: avahi-daemon[2410]: ioctl(): Inappropriate ioctl for device

From: Michael Ellerman <[email-masked]>
Date: Thu, 06 Feb 2020 15:35:10 +1100

Christian Zigotzky <[email-masked]> writes:
> Kernel 5.5 PowerPC is also affected.

I don't know what you mean by that. What sha are you talking about?

I have a system with avahi running and everything's fine.

  # grep use- /etc/avahi/avahi-daemon.conf 
  use-ipv4=yes
  use-ipv6=yes
  
  # systemctl status -l --no-pager avahi-daemon
  ● avahi-daemon.service - Avahi mDNS/DNS-SD Stack
     Loaded: loaded (/lib/systemd/system/avahi-daemon.service; enabled; vendor preset: enabled)
     Active: active (running) since Thu 2020-02-06 14:55:34 AEDT; 38min ago
   Main PID: 1884 (avahi-daemon)
     Status: "avahi-daemon 0.7 starting up."
     CGroup: /system.slice/avahi-daemon.service
             ├─1884 avahi-daemon: running [mpe-ubuntu-le.local]
             └─1888 avahi-daemon: chroot helper
  
  Feb 06 14:55:34 mpe-ubuntu-le avahi-daemon[1884]: Registering new address record for fe80::5054:ff:fe66:2a19 on eth0.*.
  Feb 06 14:55:34 mpe-ubuntu-le avahi-daemon[1884]: Registering new address record for 10.61.141.81 on eth0.IPv4.
  Feb 06 14:55:34 mpe-ubuntu-le avahi-daemon[1884]: Registering new address record for ::1 on lo.*.
  Feb 06 14:55:34 mpe-ubuntu-le avahi-daemon[1884]: Registering new address record for 127.0.0.1 on lo.IPv4.
  Feb 06 14:55:34 mpe-ubuntu-le systemd[1]: Started Avahi mDNS/DNS-SD Stack.
  Feb 06 14:55:35 mpe-ubuntu-le avahi-daemon[1884]: Server startup complete. Host name is mpe-ubuntu-le.local. Local service cookie is 3972418141.
  Feb 06 14:55:38 mpe-ubuntu-le avahi-daemon[1884]: Leaving mDNS multicast group on interface eth0.IPv6 with address fe80::5054:ff:fe66:2a19.
  Feb 06 14:55:38 mpe-ubuntu-le avahi-daemon[1884]: Joining mDNS multicast group on interface eth0.IPv6 with address fd69:d75f:b8b5:61:5054:ff:fe66:2a19.
  Feb 06 14:55:38 mpe-ubuntu-le avahi-daemon[1884]: Registering new address record for fd69:d75f:b8b5:61:5054:ff:fe66:2a19 on eth0.*.
  Feb 06 14:55:38 mpe-ubuntu-le avahi-daemon[1884]: Withdrawing address record for fe80::5054:ff:fe66:2a19 on eth0.
  
  # uname -r
  5.5.0-gcc-8.2.0

The key question is what ioctl is it complaining about. You should be
able to find that via strace.

cheers

> Christian Zigotzky wrote:
>
> Hi All,
>
> The issue with the avahi-daemon still exist in the latest Git kernel. It's a PowerPC issue. I compiled the latest Git kernel on a PC today and there aren't any issues with the avahi daemon. Another Power Mac user reported the same issue on his G5. I tested with the AmigaOne X1000 and X5000 in the last days.
>
> I bisected today but I think the result isn't correct because it found the other problem with ordering of PCSCSI definition in esp_rev enum. I don't know how to bisect if there is another issue at the same time. Maybe "git bisect skip"?
>
> 2086faae3c55a652cfbd369e18ecdb703aacc493 is the first bad commit
> commit 2086faae3c55a652cfbd369e18ecdb703aacc493
> Author: Kars de Jong <[email-masked]>
> Date:   Tue Nov 19 21:20:20 2019 +0100
>
>     scsi: esp_scsi: Correct ordering of PCSCSI definition in esp_rev enum
>
>     The order of the definitions in the esp_rev enum is important. The values
>     are used in comparisons for chip features.
>
>     Add a comment to the enum explaining this.
>
>     Also, the actual values for the enum fields are irrelevant, so remove the
>     explicit values (suggested by Geert Uytterhoeven). This makes adding a new
>     field in the middle of the enum easier.
>
>     Finally, move the PCSCSI definition to the right place in the enum. In its
>     previous location, at the end of the enum, the wrong values are written to
>     the CONFIG3 register when used with FAST-SCSI targets.
>
>     Link: https://lore.kernel.org/r/[email-masked]
>     Signed-off-by: Kars de Jong <[email-masked]>
>     Signed-off-by: Martin K. Petersen <[email-masked]>
>
> :040000 040000 cdc128596e33fb60406b5de9b17b79623c187c1a 48ceab06439f95285e8b30181e75f9a68c25fcb5 M    drivers